{{
    config(
        schema='DW_SALES',
        materialized='incremental',
        unique_key='NATION_SK'
    )
}}

WITH STG_NATION AS
(SELECT DISTINCT N_NATIONKEY as NATION_ID, 
    N_NAME as NATION_NAME, 
    N_NATIONKEY as AUDIT_ROW_NATURAL_KEY,
    MD5(N_NAME) as AUDIT_UPDATE_CHECKSUM
 FROM {{ source('TPCH_SF1', 'NATION') }}
 ORDER BY 1)

 SELECT NVL(D.NATION_SK,DW_SALES.DIM_NATION_SEQ.nextval) NATION_SK, 
    N.NATION_ID, 
    N.NATION_NAME, 
    N.AUDIT_ROW_NATURAL_KEY,
    N.AUDIT_UPDATE_CHECKSUM,
    NVL(D.AUDIT_CREATION_DATE_TIME,SYSDATE()) as AUDIT_CREATION_DATE_TIME,
    SYSDATE() as AUDIT_UPDATE_DATE_TIME,
    '{{ invocation_id }}' AS AUDIT_GUID  
 FROM STG_NATION N
  LEFT JOIN DW_SALES.DIM_NATION D ON (N.AUDIT_ROW_NATURAL_KEY = D.AUDIT_ROW_NATURAL_KEY)
 WHERE N.AUDIT_UPDATE_CHECKSUM <> D.AUDIT_UPDATE_CHECKSUM OR D.AUDIT_UPDATE_CHECKSUM IS NULL

